## oasis3 3.mct%2Bdfsg.121022

=== examples/tutorial/Makefile ===
#
include ../../util/make_dir/make.inc
LIBPSMILE = $(ARCHDIR)/lib/libpsmile.${CHAN}.a $(ARCHDIR)/lib/libmct.a $(ARCHDIR)/lib/libmpeu.a $(ARCHDIR)/lib/libscrip.a
#
##### User configurable options #####
#
# CPP keys for model 1 (_M1) and for model 2 (_M2)
# type of decomposition :
# DECOMP_APPLE for 1D decomposition
# DECOMP_BOX for 2D decomposition
CPPKEYDECOMP_M1=DECOMP_APPLE
CPPKEYDECOMP_M2=DECOMP_APPLE
#
# Precision for REAL: USE_DOUBLE_PRECISION or NO_USE_DOUBLE_PRECISION
CPPKEYDP=USE_DOUBLE_PRECISION
#
### End User configurable options ###
#
# For single precision, add -DNO_USE_DOUBLE_PRECISION in CPPLOCAL_M1/M2
CPPLOCAL_M1 =  -D${CPPKEYDECOMP_M1} -D${CPPKEYDP}
CPPLOCAL_M2 = -D${CPPKEYDECOMP_M2} -D${CPPKEYDP}
#
OBJ_M1 =  routine_hdlerr.o read_dimgrid.o  \
          read_grid.o decomp_def.o \
          function_sent.o 
OBJ_M2 =  routine_hdlerr.o read_dimgrid.o  \
          read_grid.o decomp_def_m2.o \
          function_sent_m2.o 
#-------------------------------------------------------------------------------
# General rules
#-------------------------------------------------------------------------------
#
default: all
#
all: oasis3_psmile model1 model2 
#
# Compile and link libaries
oasis3_psmile:
	(cd ../../util/make_dir ; $(MAKE) oasis3_psmile -f TopMakefileOasis3)
#
#
#-------------------------------------------------------------------------------
# Rules for executables
#-------------------------------------------------------------------------------
#
model1: $(OBJ_M1) model1.o $(LIBPSMILE) Makefile
	$(LD) $(LDFLAGS) -o $@ $(OBJ_M1) model1.o $(LIBPSMILE) $(FLIBS)
model2: $(OBJ_M2) model2.o $(LIBPSMILE) Makefile
	$(LD) $(LDFLAGS) -o $@ $(OBJ_M2) model2.o $(LIBPSMILE) $(FLIBS)
#
#-------------------------------------------------------------------------------
# Rules for compilation
#-------------------------------------------------------------------------------
#
routine_hdlerr.o :	routine_hdlerr.F90
				$(F90) $(F90FLAGS) -c routine_hdlerr.F90
read_dimgrid.o :	read_dimgrid.F90
				$(F90) $(F90FLAGS) -c read_dimgrid.F90
read_grid.o :		read_grid.F90
				$(F90) $(F90FLAGS) -c read_grid.F90
decomp_def.o : 		decomp_def.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M1) -c decomp_def.F90
function_sent.o :	function_sent.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M1) -c function_sent.F90
decomp_def_m2.o : 	decomp_def.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M2) -o decomp_def_m2.o -c decomp_def.F90
function_sent_m2.o :	function_sent.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M2) -o function_sent_m2.o -c function_sent.F90

model1.o :	model1.F90 Makefile
		$(F90) $(F90FLAGS) $(CPPLOCAL_M1) -c model1.F90
model2.o :	model2.F90 Makefile
		$(F90) $(F90FLAGS) $(CPPLOCAL_M2) -c model2.F90
#
#-------------------------------------------------------------------------------
# Utilities
#-------------------------------------------------------------------------------
#
help:
	more Make.help
#
# Clean directory
#
clean:
	-rm -f *.o *.mod *.MOD model1 model2
	-rm -f i.*.F90 *.L
	-rm -f core core.* 
#
# Make sure to recompile everything
#
realclean: clean remove
remove:
	(cd ../../util/make_dir ; $(MAKE) realclean -f TopMakefileOasis3)

=== lib/mct/examples/Makefile ===

SHELL = /bin/sh

SUBDIRS = simple climate_concur1 climate_sequen1

# TARGETS
subdirs:
	@for dir in $(SUBDIRS); do \
	  cd $$dir;                \
	  $(MAKE);                 \
	  cd ..;                   \
	done

clean:
	@for dir in $(SUBDIRS); do \
	  cd $$dir;                \
	  $(MAKE) clean;           \
	  cd ..;                   \
	done

=== lib/mct/mct/Makefile ===
.NOTPARALLEL:
SHELL           = /bin/sh
VPATH=$(SRCDIR)/mct 
# SOURCE FILES

MODULE		= mct

SRCS_F90	= m_MCTWorld.F90		\
		  m_AttrVect.F90		\
		  m_GlobalMap.F90	        \
		  m_GlobalSegMap.F90		\
		  m_GlobalSegMapComms.F90	\
		  m_Accumulator.F90		\
		  m_SparseMatrix.F90      	\
		  m_Navigator.F90		\
		  m_AttrVectComms.F90		\
		  m_AttrVectReduce.F90		\
		  m_AccumulatorComms.F90  	\
		  m_GeneralGrid.F90		\
		  m_GeneralGridComms.F90	\
		  m_SpatialIntegral.F90		\
		  m_SpatialIntegralV.F90	\
		  m_MatAttrVectMul.F90    	\
		  m_Merge.F90			\
		  m_GlobalToLocal.F90		\
		  m_ExchangeMaps.F90		\
		  m_ConvertMaps.F90		\
		  m_SparseMatrixDecomp.F90	\
		  m_SparseMatrixToMaps.F90	\
		  m_SparseMatrixComms.F90 	\
		  m_SparseMatrixPlus.F90	\
		  m_Router.F90			\
		  m_Rearranger.F90        	\
		  m_Transfer.F90                \
                  mct_mod.F90


OBJS_ALL	= $(SRCS_F90:.F90=.o)

# MACHINE AND COMPILER FLAGS

include ../Makefile.conf

# TARGETS

all: 	lib$(MODULE).a

lib$(MODULE).a:	$(OBJS_ALL)
	$(RM) $@
	$(AR) $@ $(OBJS_ALL)

# ADDITIONAL FLAGS SPECIFIC FOR MCT COMPILATION

MCTFLAGS = $(INCFLAG)$(MPEUPATH)

# RULES

.SUFFIXES:
.SUFFIXES: .F90 .o

.F90.o:
	$(FC) -c $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MCTFLAGS) $<


clean:
	${RM} *.o *.mod lib$(MODULE).a

install: all
	$(MKINSTALLDIRS) $(libdir) $(includedir)
	$(INSTALL) lib$(MODULE).a -m 644 $(libdir)
	@for modfile in *.mod; do                         \
	  echo $(INSTALL) $$modfile -m 644 $(includedir); \
	  $(INSTALL) $$modfile -m 644 $(includedir);      \
	done

# DEPENDENCIES

$(OBJS_ALL): $(MPEUPATH)/libmpeu.a

m_AttrVect.o: 
m_Accumulator.o: m_AttrVect.o
m_GlobalMap.o:
m_GlobalSegMap.o:
m_GlobalSegMapComms.o: m_GlobalSegMap.o
m_Navigator.o:
m_AttrVectComms.o: m_AttrVect.o m_GlobalMap.o
m_AttrVectReduce.o: m_AttrVect.o
m_AccumulatorComms.o: m_AttrVect.o m_GlobalMap.o m_AttrVectComms.o
m_SparseMatrix.o: m_AttrVect.o m_GlobalMap.o m_AttrVectComms.o
m_GeneralGrid.o: m_AttrVect.o
m_GeneralGridComms.o: m_AttrVect.o m_GeneralGrid.o m_AttrVectComms.o m_GlobalMap.o m_GlobalSegMap.o
m_MatAttrVectMul.o: m_AttrVect.o m_SparseMatrix.o m_GlobalMap.o m_GlobalSegMap.o m_SparseMatrixPlus.o m_Rearranger.o
m_Merge.o: m_AttrVect.o m_GeneralGrid.o
m_Router.o: m_GlobalToLocal.o m_MCTWorld.o m_GlobalSegMap.o m_ExchangeMaps.o
m_Rearranger.o: m_Router.o m_MCTWorld.o m_GlobalSegMap.o m_AttrVect.o
m_GlobalToLocal.o: m_GlobalSegMap.o
m_ExchangeMaps.o: m_GlobalMap.o m_GlobalSegMap.o m_MCTWorld.o m_ConvertMaps.o
m_ConvertMaps.o: m_GlobalMap.o m_GlobalSegMap.o m_MCTWorld.o
m_SparseMatrixDecomp.o: m_SparseMatrix.o m_GlobalSegMap.o
m_SparseMatrixToMaps.o: m_SparseMatrix.o m_GlobalSegMap.o
m_SparseMatrixComms.o:	m_SparseMatrix.o m_SparseMatrixDecomp.o m_GlobalSegMap.o m_AttrVectComms.o
accumulate.o: m_AttrVect.o m_Accumulator.o
m_SpatialIntegral.o: m_SpatialIntegralV.o m_GeneralGrid.o m_AttrVect.o m_AttrVectReduce.o
m_SpatialIntegralV.o: m_AttrVect.o m_AttrVectReduce.o
m_Transfer.o: m_AttrVect.o m_Router.o m_MCTWorld.o
m_SparseMatrixPlus.o: m_GlobalSegMap.o m_Rearranger.o m_SparseMatrix.o m_SparseMatrixComms.o m_SparseMatrixToMaps.o m_GlobalToLocal.o

=== debian/changelog ===
oasis3 (3.mct+dfsg.121022-16build5) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 26 Jan 2026 20:25:38 +0000

oasis3 (3.mct+dfsg.121022-16build4) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 16:09:18 +0000

oasis3 (3.mct+dfsg.121022-16build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:37:56 +0000

oasis3 (3.mct+dfsg.121022-16build2) noble; urgency=high

  * No change rebuild against libnetcdf19t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:44:42 +0100

oasis3 (3.mct+dfsg.121022-16build1) jammy; urgency=medium

  * No-change rebuild against libnetcdf19

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 30 Oct 2021 10:39:54 +0000

oasis3 (3.mct+dfsg.121022-16) unstable; urgency=medium

  * Invert gfortran conditional to support gf11. Closes: #984264
  * Standards-Version 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Oct 2021 12:27:44 +0000

oasis3 (3.mct+dfsg.121022-15) unstable; urgency=medium

  * FTBFS with gfortran-10 due to new warnings on C/Fortran interface.
    Closes: #947622

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 05 Aug 2020 08:41:46 +0100

oasis3 (3.mct+dfsg.121022-14) unstable; urgency=medium

  * Standards-Version: 4.4.1
  * Mark liboasis3-doc as M-A: foreign
  * Patch from Bas Couwenberg for protex FTBFS. Closes:  #949134
  * Patch to escape chars that break new protex patch

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Feb 2020 14:41:44 +0000

oasis3 (3.mct+dfsg.121022-13) unstable; urgency=medium

  * Standards-Version: 4.2.1
  * Patch from Andreas  Beckmann to ship SONAME link. Closes: #864280

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Oct 2018 10:41:07 +0100

oasis3 (3.mct+dfsg.121022-12) unstable; urgency=medium

  * Standards-Version: 4.1.5
  * Move VCS to salsa.d.o
  * Rebuild for gfortran transition. Closes: #897822

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Jul 2018 17:35:15 +0100

oasis3 (3.mct+dfsg.121022-11) unstable; urgency=medium

  * Standards-Version: 4.1.3
  * Rebuild for gfortran .mod changes for reproduciblity
  * liboasis3-doc now M-A: foreign
  * Drop obsolete Pre-Depends for M-A

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Mar 2018 07:08:07 +0000

oasis3 (3.mct+dfsg.121022-10) unstable; urgency=medium

  * Standards-Version: 4.1.2; no changes required
  * DH_COMPAT level now 10
  * Priority: now optional, not extra

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Dec 2017 15:20:30 +0000

oasis3 (3.mct+dfsg.121022-9) unstable; urgency=medium

  * Ensure ${CHAN} present in symlink. Closes: #827122

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 May 2017 16:33:40 +0100

oasis3 (3.mct+dfsg.121022-8) unstable; urgency=medium

  * Fix broken symlink libpsmile.so.0d. Closes: #827122
  * Standards-Version: 3.9.8. No changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 May 2017 07:16:56 +0100

oasis3 (3.mct+dfsg.121022-7) unstable; urgency=medium

  * Include patch that was accidentally dropped. Closes: #807818

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 Jan 2016 02:16:16 +0000

oasis3 (3.mct+dfsg.121022-6) ubstable; urgency=medium

  * Patch from Reiner Herrmann to make build reproducible.
    Closes: #807818.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Dec 2015 10:58:42 +0000

oasis3 (3.mct+dfsg.121022-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move from experimental to unstable for netcdf transition.
    (closes: #793920)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 19 Aug 2015 22:58:29 +0200

oasis3 (3.mct+dfsg.121022-5) experimental; urgency=medium

  * Rebuild against libnetcdff-dev (>= 4.4.3) in experimental 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 29 Jul 2015 05:06:22 +0100

oasis3 (3.mct+dfsg.121022-4) experimental; urgency=medium

  * Rebuild with netcdf 4.3.3 in experimental 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jul 2015 19:13:10 +0100

oasis3 (3.mct+dfsg.121022-3) unstable; urgency=medium

  * Rebuild for netcdf, gcc5 transition. Closes: #778031.
  * Now at Standards-Version: 3.9.6. No changes required.
  * Add Vcs-Git pointing to debian-science repo. 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jul 2015 21:29:36 +0100

oasis3 (3.mct+dfsg.121022-2) unstable; urgency=medium

  * Fix missing build-dep; need ghostscript not just tex*
   Closes: #759185.
  * Ack. the  removal of unnecessary hdf5 dependency. Closes: #755681.
  * Removal of ${CHAN} from libnames fixes soname/symlink error.
    Closes: #706291.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Aug 2014 20:57:26 +0100

oasis3 (3.mct+dfsg.121022-1) unstable; urgency=medium

  * New upstream release. Now ship just libpsmile,scrip, mct not
  and not a separate executable. Same library linking, though.
  * Standards-Version: 3.9.5
  * Remove unnecessary build-deps on HDF5.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Jul 2014 15:25:06 +0100

## oasis3 3.mct+dfsg.121022

=== examples/test_interpolation/Makefile ===
#
include header_Makefile
LIBPSMILE = $(ARCHDIR)/lib/libpsmile.${CHAN}.a $(ARCHDIR)/lib/libmct.a $(ARCHDIR)/lib/libmpeu.a $(ARCHDIR)/lib/libscrip.a
#
##### User configurable options #####
#
# CPP keys for model 1 (_M1) and for model 2 (_M2)
# type of decomposition :
# DECOMP_APPLE for 1D decomposition
# DECOMP_BOX for 2D decomposition
CPPKEYDECOMP_M1=DECOMP_APPLE
CPPKEYDECOMP_M2=DECOMP_APPLE
#
# Precision for REAL: USE_DOUBLE_PRECISION or NO_USE_DOUBLE_PRECISION
include header_precision
CPPLOCAL_M1 = -D${CPPKEYDP} -D${CPPKEYDECOMP_M1}
CPPLOCAL_M2 = -D${CPPKEYDP} -D${CPPKEYDECOMP_M2}
#
### End User configurable options ###
#
OBJ_M1 =  routine_hdlerr.o read_all_data.o \
          decomp_def.o \
          function_ana.o write_all_fields.o
OBJ_M2 =  routine_hdlerr.o read_all_data.o \
          decomp_def_m2.o \
          function_ana.o  write_all_fields.o
#-------------------------------------------------------------------------------
# General rules
#-------------------------------------------------------------------------------
#
default: all
#
all: oasis3_psmile model1 model2
#
# Compile and link libaries
oasis3_psmile:
	(cd $(O3DIR)/util/make_dir ; $(MAKE) oasis3_psmile -f TopMakefileOasis3)
#
#
#-------------------------------------------------------------------------------
# Rules for executables
#-------------------------------------------------------------------------------
#
model1: $(OBJ_M1) model1.o $(LIBPSMILE) Makefile
	$(LD) $(LDFLAGS) -o $@ $(OBJ_M1) model1.o $(LIBPSMILE) $(FLIBS)
model2: $(OBJ_M2) model2.o $(LIBPSMILE) Makefile
	$(LD) $(LDFLAGS) -o $@ $(OBJ_M2) model2.o $(LIBPSMILE) $(FLIBS)
#
#-------------------------------------------------------------------------------
# Rules for compilation
#-------------------------------------------------------------------------------
#
routine_hdlerr.o :		routine_hdlerr.F90
				$(F90) $(F90FLAGS) -c routine_hdlerr.F90
read_all_data.o :		read_all_data.F90
				$(F90) $(F90FLAGS) -D${CPPKEYDP} -c read_all_data.F90
write_all_fields.o :		write_all_fields.F90
				$(F90) $(F90FLAGS) -D${CPPKEYDP} -c write_all_fields.F90
function_ana.o :		function_ana.F90
				$(F90) $(F90FLAGS) -D${CPPKEYDP} -c function_ana.F90
decomp_def.o : 			decomp_def.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M1) -c decomp_def.F90
decomp_def_m2.o : 		decomp_def.F90
				$(F90) $(F90FLAGS) $(CPPLOCAL_M2) -o decomp_def_m2.o -c decomp_def.F90

model1.o :	model1.F90 Makefile
		$(F90) $(F90FLAGS) $(CPPLOCAL_M1) -c model1.F90
model2.o :	model2.F90 Makefile
		$(F90) $(F90FLAGS) $(CPPLOCAL_M2) -c model2.F90
#
#-------------------------------------------------------------------------------
# Utilities
#-------------------------------------------------------------------------------
#
help:
	more Make.help
#
# Clean directory
#
clean:
	-rm -f *.o *.mod *.MOD model1 model2
	-rm -f i.*.F90 *.L
	-rm -f core core.* 
#
# Make sure to recompile everything
#
realclean: clean remove
remove:
	(cd $(O3DIR)/util/make_dir ; $(MAKE) realclean -f TopMakefileOasis3)

=== lib/mct/Makefile ===

SHELL = /bin/sh

include Makefile.conf

SUBDIRS = $(MPISERPATH) $(MPEUPATH) $(MCTPATH)

# TARGETS
subdirs:
	@set -e; for dir in $(SUBDIRS); do \
	  cd $$dir;                \
	  $(MAKE);                 \
	  cd $(abs_top_builddir);  \
	done

clean:
	@set -e; for dir in $(SUBDIRS); do \
	  cd $$dir;                \
	  $(MAKE) clean;           \
	  cd $(abs_top_builddir);  \
	done

install: subdirs
	@set -e; for dir in $(SUBDIRS); do \
	  cd $$dir;                \
	  $(MAKE) install;         \
	  cd $(abs_top_builddir);  \
	done

examples: subdirs
	@cd $(EXAMPLEPATH) && $(MAKE)

=== lib/mct/doc/Makefile ===
#!/bin/make
#-----------------------------------------------------------------------
# Documentation
all: 
	cd texsrc; make
	make apis
	
html:
	latex2html -white -toc_depth 5 -split 4 -show_section_numbers \
	-address "<A HREF="mailto:jacob@mcs.anl.gov">jacob@mcs.anl.gov</A>" \
	mct_APIs.tex
apis:
	cd texsrc; make
	make apisdvi

apisdvi: mct_APIs.dvi

clean:
	cd texsrc; make clean
	rm -f *.dvi *.log *.bbl *.blg *.aux *.toc

.SUFFIXES: .dvi .tex

.tex.dvi:
	latex $*.tex

#.

=== lib/mct/mpeu/Makefile ===
.NOTPARALLEL:
# MACHINE AND COMPILER FLAGS

include ../Makefile.conf

VPATH = $(SRCDIR)/mpeu
SHELL           = /bin/sh

INCPATH += $(INCFLAG). $(INCFLAG)../

# SOURCE FILES

MODULE		= mpeu

SRCS_F90	= m_IndexBin_char.F90		\
		  m_IndexBin_integer.F90	\
		  m_IndexBin_logical.F90	\
		  m_List.F90			\
		  m_MergeSorts.F90		\
		  m_Filename.F90		\
		  m_FcComms.F90                 \
		  m_Permuter.F90		\
		  m_SortingTools.F90		\
		  m_String.F90			\
		  m_StrTemplate.F90		\
		  m_chars.F90			\
		  m_die.F90			\
		  m_dropdead.F90		\
                  m_FileResolv.F90		\
		  m_flow.F90			\
		  m_inpak90.F90			\
		  m_ioutil.F90			\
		  m_mall.F90			\
		  m_mpif.F90			\
		  m_mpif90.F90			\
		  m_mpout.F90			\
		  m_rankMerge.F90		\
		  m_realkinds.F90		\
		  m_stdio.F90			\
		  m_TraceBack.F90		\
		  m_zeit.F90

SRCS_C		= get_zeits.c

OBJS_ALL	= $(SRCS_C:.c=.o)  \
		  $(SRCS_F90:.F90=.o)


# TARGETS

all:	lib$(MODULE).a

lib$(MODULE).a:	$(OBJS_ALL)
	$(RM) $@
	$(AR) $@ $(OBJS_ALL)

# ADDITIONAL FLAGS SPECIFIC FOR MPEU COMPILATION

MPEUFLAGS =

# RULES

.SUFFIXES:
.SUFFIXES: .F90 .c .o

.c.o:
	$(CC) -c $(CPPDEFS) $(CFLAGS) $(INCPATH) $<

.F90.o:
	$(FC) -c $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MPEUFLAGS) $<

clean:
	${RM} *.o *.mod lib$(MODULE).a

install: all
	$(MKINSTALLDIRS) $(libdir) $(includedir)
	$(INSTALL) lib$(MODULE).a -m 644 $(libdir)
	@for modfile in *.mod; do                         \
	  echo $(INSTALL) $$modfile -m 644 $(includedir); \
	  $(INSTALL) $$modfile -m 644 $(includedir);      \
	done

# DEPENDENCIES

m_IndexBin_char.o: m_die.o m_stdio.o
m_IndexBin_integer.o: m_die.o m_stdio.o
m_IndexBin_logical.o: m_die.o m_stdio.o
m_List.o: m_String.o m_die.o m_mall.o
m_MergeSorts.o: m_die.o m_realkinds.o m_stdio.o
m_Filename.o:
m_Permuter.o: m_die.o m_realkinds.o
m_SortingTools.o: m_IndexBin_char.o m_IndexBin_integer.o m_IndexBin_logical.o m_MergeSorts.o m_Permuter.o m_rankMerge.o
m_String.o: m_die.o m_mall.o m_mpif90.o
m_StrTemplate.o: m_chars.o m_die.o m_stdio.o
m_chars.o:
m_die.o: m_dropdead.o m_flow.o m_mpif90.o m_mpout.o m_stdio.o
m_dropdead.o: m_mpif90.o m_stdio.o
m_flow.o: m_chars.o
m_inpak90.o: m_die.o m_ioutil.o m_mall.o m_mpif90.o m_realkinds.o m_stdio.o
m_ioutil.o: m_stdio.o
m_mall.o: m_chars.o m_die.o m_ioutil.o m_realkinds.o m_stdio.o
m_mpif.o:
m_mpif90.o: m_mpif.o m_realkinds.o m_stdio.o
m_mpout.o: m_dropdead.o m_ioutil.o m_mpif90.o m_stdio.o
m_rankMerge.o:
m_realkinds.o:
m_stdio.o:
m_zeit.o: m_SortingTools.o m_die.o m_ioutil.o m_mpif90.o m_stdio.o get_zeits.o
get_zeits.o:
m_FileResolv.o: m_die.o m_StrTemplate.o
m_TraceBack.o:	m_die.o m_stdio.o m_String.o

=== lib/mct/mpi-serial/Makefile ===
SHELL		= /bin/sh
###############################
include ../Makefile.conf

VPATH=$(SRCDIR)/mpi-serial
# SOURCE FILES

MODULE		= mpi-serial

SRCS_F90	= fort.F90

SRCS_C		= mpi.c \
		  send.c \
		  recv.c \
		  collective.c \
		  req.c \
		  list.c \
		  handles.c \
                  comm.c \
                  group.c \
                  time.c \
                  pack.c


OBJS_ALL	= $(SRCS_C:.c=.o) \
		  $(SRCS_F90:.F90=.o)


INCPATH:= $(INCFLAG)$(SRCDIR)/mpi-serial $(INCFLAG). $(INCFLAG)../ $(INCPATH)

#
# The values used from Makefile.conf
#

# ALLCFLAGS= -DFORTRAN_UNDERSCORE_
# ALLCFLAGS= -DFORTRAN_SAME
# ALLCFLAGS= -DFORTRAN_CAPS

# FC=pgf90
# AR=ar rv
# CC=cc


###############################

# TARGETS

default: lib$(MODULE).a

examples: ctest ftest


MPIFH= mpif.$(FORT_SIZE).h


mpif.h: $(MPIFH)
	cp -f $< $@

fort.o: mpif.h

lib:
	@if [ ! "$(FORT_SIZE)" ] ; \
           then echo "Please set FORT_SIZE (e.g. real4double8 or real8double16) when you do the main MCT configure"; \
                exit 1; fi
	@if [ ! -r $(MPIFH) ] ; \
           then echo "Error: there is no $(MPIFH) -" \
                      "check the value of FORT_SIZE in the main MCT configure" ; \
                exit 1; fi
	cp -f $(MPIFH) mpif.h
	chmod -w mpif.h
	$(MAKE) $(LIB)



lib$(MODULE).a: $(OBJS_ALL)
	echo $(OBJS_ALL)
	$(RM) $@
	$(AR) $@ $(OBJS_ALL)


LIB	= lib$(MODULE).a


###############################
#RULES

.SUFFIXES:
.SUFFIXES: .F90 .c .o 

.c.o:
	$(CC) -c $(INCPATH) $(CFLAGS) $<

.F90.o:
	$(FC) -c $(INCFLAG). $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MPEUFLAGS) $<

MYF90FLAGS=$(INCPATH) $(DEFS) $(FCFLAGS)  $(MPEUFLAGS)

clean:
	/bin/rm -f *.o ctest ftest $(LIB) mpif.h


install: lib
	$(MKINSTALLDIRS) $(libdir) $(includedir)
	$(INSTALL) lib$(MODULE).a -m 644 $(libdir)
	$(INSTALL) mpi.h -m 644 $(includedir)
	$(INSTALL) mpif.h -m 644 $(includedir)



###############################
#
# Create mpif.realXdoubleY.h filesfrom mpif.master.h template
#

mpif:
	make-mpif 4 8
	make-mpif 8 8
	make-mpif 8 16


###############################

#
# test programs
#


ctest: lib ctest.c
	$(CC) $(ALLCFLAGS) -o $@ ctest.c -L. -lmpi-serial

ftest: lib ftest.F90
	$(FC) $(MYF90FLAGS) -o $@ ftest.F90 -L. -lmpi-serial

=== lib/psmile/src/Makefile ===

SRCS1	= $(shell ls $(COUPLE)/lib/psmile/src/*.F90)
OBJS1	= $(patsubst $(COUPLE)/lib/psmile/src/%.F90, %.o, $(SRCS1))

VPATH 	= .:$(COUPLE)/lib/psmile/src:\
	     $(COUPLE)/lib/psmile/include:\
	     $(NETCDF_INCLUDE):$(MPI_INCLUDE)

LIBRARY = $(ARCHDIR)/lib/libpsmile.${CHAN}.a

clean:
	rm -f i.* *.o *.mod

all:	$(LIBRARY)

$(LIBRARY): $(OBJS1) 
	$(AR) $(ARFLAGS) $(LIBRARY) $(OBJS1) 

INCLS = -I$(COUPLE)/lib/psmile/include \
        -I$(ARCHDIR)/build/lib/mct \
        -I$(ARCHDIR)/build/lib/scrip \
        -I$(ARCHDIR)/build/lib/pio

INCLSC = -I$(COUPLE)/lib/psmile/include
.SUFFIXES:
.SUFFIXES: .o .F90 .c

%.o: %.F90
	$(F90) $(F90FLAGS) $(INCLS)  -c   $<

%.o: %.c
	$(CC) $(CCFLAGS) $(INCLSC) -c   $<

mod_psmile_io.o: mod_psmile_io.F90
	$(F90) $(F90FLAGS) $(INCLS)  -c   $<

#
# ALL dependencies ...
#

mod_oasis_kinds.o: 
mod_oasis_parameters.o: mod_oasis_kinds.o
mod_oasis_data.o: mod_oasis_kinds.o 
mod_oasis_sys.o: mod_oasis_kinds.o mod_oasis_data.o
mod_oasis_mpi.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o
mod_oasis_timer.o: mod_oasis_kinds.o mod_oasis_sys.o mod_oasis_mpi.o mod_oasis_data.o
mod_oasis_string.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o
mod_oasis_namcouple.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_mpi.o mod_oasis_string.o
mod_oasis_var.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o
mod_oasis_part.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_timer.o
mod_oasis_ioshr.o:  mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_mpi.o mod_oasis_string.o
mod_oasis_io.o:  mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_ioshr.o mod_oasis_mpi.o
mod_oasis_grid.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_io.o
mod_oasis_coupler.o: mod_oasis_kinds.o  mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_mpi.o mod_oasis_var.o mod_oasis_part.o  \
        mod_oasis_string.o mod_oasis_namcouple.o mod_oasis_timer.o mod_oasis_io.o
mod_oasis_advance.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_var.o mod_oasis_part.o mod_oasis_mpi.o \
        mod_oasis_coupler.o mod_oasis_timer.o mod_oasis_io.o
mod_oasis_method.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_coupler.o mod_oasis_namcouple.o \
        mod_oasis_timer.o mod_oasis_ioshr.o mod_oasis_advance.o mod_oasis_grid.o \
        mod_oasis_mpi.o
mod_oasis_getput_interface.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_var.o mod_oasis_advance.o 
mod_oasis_auxiliary_routines.o: mod_oasis_kinds.o mod_oasis_data.o mod_oasis_sys.o \
        mod_oasis_parameters.o mod_oasis_var.o mod_oasis_mpi.o \
        mod_oasis_coupler.o mod_oasis_timer.o mod_oasis_io.o
mod_prism.o: mod_oasis_kinds.o mod_oasis_part.o mod_oasis_sys.o \
	mod_oasis_getput_interface.o mod_oasis_parameters.o \
	mod_oasis_grid.o mod_oasis_method.o mod_oasis_var.o \
	mod_oasis_namcouple.o mod_oasis_auxiliary_routines.o
mod_oasis.o: mod_oasis_kinds.o mod_oasis_part.o mod_oasis_sys.o \
	mod_oasis_getput_interface.o mod_oasis_parameters.o \
	mod_oasis_grid.o mod_oasis_method.o mod_oasis_var.o \
	mod_oasis_namcouple.o mod_oasis_auxiliary_routines.o

=== lib/scrip/src/Makefile ===

SRCS1 =  $(shell ls $(COUPLE)/lib/scrip/src/*.F90)
OBJS1 =  $(patsubst $(COUPLE)/lib/scrip/src/%.F90, %.o, $(SRCS1))

SRCS3   = $(shell ls $(COUPLE)/lib/scrip/src/*.F)
OBJS3   = $(patsubst $(COUPLE)/lib/scrip/src/%.F, %.o, $(SRCS3))

SRCS4 =  $(shell ls $(COUPLE)/lib/scrip/src/*.f)
OBJS4 =  $(patsubst $(COUPLE)/lib/scrip/src/%.f, %.o, $(SRCS4))

VPATH =	.:$(COUPLE)/lib/scrip/src:$(COUPLE)/src

LIBRARY	= $(ARCHDIR)/lib/libscrip.a

clean:
	rm -f i.* *.o *.mod

all:	$(LIBRARY)

$(LIBRARY): $(OBJS1)  $(OBJS3) $(OBJS4)
	$(AR) $(ARFLAGS) $(LIBRARY) $(OBJS1) $(OBJS3) $(OBJS4)

.SUFFIXES:
.SUFFIXES: .o .f .F .f90 .F90 .c

%.o: %.F90
	$(F90) $(F90FLAGS) -c   $<

%.o: %.f90
	$(f90) $(f90FLAGS) -c   $<

%.o: %.F
	$(F) $(FFLAGS) -c   $<

%.o: %.f
	$(f) $(fFLAGS) -c   $<

%.o: %.c
	$(CC) $(CCFLAGS) -c   $<

#
# ALL dependencies ...
#
mod_oasis_flush.o : kinds_mod.o
remap_bicubic_reduced.o: constants.o grids.o remap_vars.o
netcdf.o: constants.o kinds_mod.o 
remap_conserv.o: constants.o grids.o kinds_mod.o remap_vars.o timers.o
remap_distwgt.o: constants.o grids.o kinds_mod.o remap_vars.o
remap_vars.o: constants.o grids.o kinds_mod.o
scrip.o: constants.o grids.o iounits.o kinds_mod.o remap_bicubic.o \
	remap_bicubic_reduced.o remap_bilinear.o remap_bilinear_reduced.o \
	remap_conserv.o remap_distwgt.o remap_gauswgt.o remap_vars.o \
	remap_write.o timers.o
constants.o: kinds_mod.o
distance.o: constants.o kinds_mod.o
fracnnei.o: constants.o grids.o kinds_mod.o remap_vars.o 
gradient_bicubic.o: constants.o kinds_mod.o 
grids.o: constants.o iounits.o kinds_mod.o 
iounits.o: kinds_mod.o 
kinds_mod.o: 
remap_bicubic.o: constants.o grids.o kinds_mod.o remap_vars.o
remap_bilinear.o: constants.o grids.o kinds_mod.o remap_vars.o
remap_bilinear_reduced.o: constants.o grids.o kinds_mod.o remap_vars.o
remap_gauswgt.o: constants.o grids.o kinds_mod.o remap_vars.o
remap_write.o: constants.o grids.o kinds_mod.o netcdf.o remap_vars.o 
timers.o: kinds_mod.o

=== lib/mct/doc/texsrc/Makefile ===
#!/bin/make

TEXFILES	=
include SRCS_tex.mk

PROTEXLOC	= ../../protex/protex

PROTEX          = perl $(PROTEXLOC) -b # bare mode--no TOC

#-----------------------------------------------------------------------
# Documentation
all:
	cp ../../mct/*.F90 .
	cp ../../mpeu/m_String.F90 .
	cp ../../mpeu/m_List.F90 .
	make doc

doc: $(TEXFILES)

clean:
	rm -f *.F90
	rm -f *.tex

.SUFFIXES: .F90 .tex

.F90.tex:
	$(PROTEX) $*.F90 > $*.tex

#.

=== lib/mct/examples/climate_concur1/Makefile ===

SHELL           = /bin/sh

# SOURCE FILES

SRCS_F90	= master.F90 coupler.F90 model.F90

OBJS_ALL	= $(SRCS_F90:.F90=.o)

# MACHINE AND COMPILER FLAGS

include ../../Makefile.conf

# ADDITIONAL FLAGS SPECIFIC FOR UTMCT COMPILATION

MCTLIBS    = -L$(MPEUPATH) -L$(MCTPATH) -lmct -lmpeu 
UTLDFLAGS  = $(REAL8)
UTCMPFLAGS = $(REAL8) $(INCFLAG)$(MPEUPATH) $(INCFLAG)$(MCTPATH)

# TARGETS

all: climate

climate: $(OBJS_ALL) 
	$(FC) -o $@ $(OBJS_ALL) $(FCFLAGS) $(UTLDFLAGS) $(MCTLIBS) $(MPILIBS)

# RULES

.SUFFIXES:
.SUFFIXES: .F90 .o

.F90.o:
	$(FC) -c $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MCTFLAGS) $(UTCMPFLAGS) $<


clean:
	${RM} *.o *.mod climate

# DEPENDENCIES:

$(OBJS_ALL): $(MCTPATH)/libmct.a

=== lib/mct/examples/climate_sequen1/Makefile ===

SHELL           = /bin/sh

# SOURCE FILES

SRCS_F90	= mutils.F90 srcmodel.F90 dstmodel.F90 coupler.F90 master.F90

OBJS_ALL	= $(SRCS_F90:.F90=.o)

# MACHINE AND COMPILER FLAGS

include ../../Makefile.conf

# ADDITIONAL FLAGS SPECIFIC FOR UTMCT COMPILATION

MCTLIBS    = -L$(MPEUPATH) -L$(MCTPATH) -lmct -lmpeu 
UTLDFLAGS  = $(REAL8)
UTCMPFLAGS = $(REAL8) $(INCFLAG)$(MPEUPATH) $(INCFLAG)$(MCTPATH)

# TARGETS

all: climate

climate: $(OBJS_ALL) 
	$(FC) -o $@ $(OBJS_ALL) $(FCFLAGS) $(UTLDFLAGS) $(MCTLIBS) $(MPILIBS)

# RULES

.SUFFIXES:
.SUFFIXES: .F90 .o

.F90.o:
	$(FC) -c $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MCTFLAGS) $(UTCMPFLAGS) $<

clean:
	${RM} *.o *.mod climate

# DEPENDENCIES:

$(OBJS_ALL): $(MCTPATH)/libmct.a

=== lib/mct/examples/simple/Makefile ===

SHELL           = /bin/sh

# SOURCE FILES

SRCS_F90	= twocmp.con.F90		\
		  twocmp.seq.F90		\
		  twocmp.seqUnvn.F90		\
		  twocmp.seqNB.F90		\

OBJS_ALL	= $(SRCS_F90:.F90=.o)

# MACHINE AND COMPILER FLAGS

include ../../Makefile.conf

# ADDITIONAL DEFINITIONS SPECIFIC FOR UTMCT COMPILATION

MCTLIBS    = -L$(MPEUPATH) -L$(MCTPATH) -lmct -lmpeu 
UTLDFLAGS  = $(REAL8)
UTCMPFLAGS = $(REAL8) $(INCFLAG)$(MPEUPATH) $(INCFLAG)$(MCTPATH)

# TARGETS

all:	twocon twoseq twosequn twoseqNB

twocon:  twocmp.con.o
	$(FC) -o $@ twocmp.con.o $(FCFLAGS) $(UTLDFLAGS) $(MCTLIBS) $(MPILIBS)

twoseq:  twocmp.seq.o
	$(FC) -o $@ twocmp.seq.o $(FCFLAGS) $(UTLDFLAGS) $(MCTLIBS) $(MPILIBS)

twosequn:  twocmp.seqUnvn.o
	$(FC) -o $@ twocmp.seqUnvn.o $(FCFLAGS) $(UTLDFLAGS) $(MCTLIBS) $(MPILIBS)

twoseqNB:  twocmp.seqNB.o
	$(FC) -o $@ twocmp.seqNB.o $(FCFLAGS) $(MCTLIBS) $(MPILIBS)

# RULES

.SUFFIXES:
.SUFFIXES: .F90 .o

.F90.o:
	$(FC) -c $(INCPATH) $(FPPDEFS) $(FCFLAGS) $(MCTFLAGS) $(UTCMPFLAGS) $<


clean:
	${RM} *.o *.mod twocon twoseq twosequn twoseqNB

# DEPENDENCIES:

$(OBJS_ALL): $(MCTPATH)/libmct.a

=== debian/control ===
Source: oasis3
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: mpi-default-dev, debhelper (>= 9), gfortran, 
 libnetcdf-dev (>= 1:4.3.3.1), libnetcdff-dev,
 libcurl4-gnutls-dev,
 texlive-latex-base, texlive-latex-extra, ghostscript
Standards-Version: 3.9.8
Homepage: http://www.prism.enes.org/PAEs/coupling_IO/software_OASIS3.php
Vcs-Git: git://anonscm.debian.org/debian-science/packages/oasis3.git

Package: liboasis3-0d
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: oasis3
Replaces: oasis3
Description: Shared libraries for OASIS3 coupler
 OASIS3-MCT is a library for exchanging via MPI fields between
 components of climate models, such as atmosphere and ocean models.
 In addition, OASIS can perform interpolation between different grids
 used by the components, via the SCRIP library.
 .
 This package contains the shared libraries used in OASIS3.

Package: liboasis3-dev
Section: libdevel
Architecture: any
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-dev, liboasis3-0d (=${binary:Version})
Recommends: oasis3-examples, pkg-config
Description: Development files for OASIS3 climate model coupler
 OASIS3-MCT is a library for exchanging via MPI fields between
 components of climate models, such as atmosphere and ocean models.
 In addition, OASIS can perform interpolation between different grids
 used by the components, via the SCRIP library.
 .
 This package contains development files for building against OASIS3.

Package: liboasis3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: liboasis3-dev
Description: Documentation and Examples for the OASIS climate model coupler
 OASIS3-MCT is a library for exchanging via MPI fields between
 components of climate models, such as atmosphere and ocean models.
 In addition, OASIS can perform interpolation between different grids
 used by the components, via the SCRIP library.
 .
 This package contains example models and sources for the OASIS3 coupler.

=== debian/rules ===
#!/usr/bin/make -f

# The magic rule ...
%:
	dh $@

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
LIBDIR_ESC:=\/usr\/lib\/${DEB_HOST_MULTIARCH}
VERSION:= 3+mct+dfsg.121022
CHAN := MPI1

TOP:=$(shell pwd)/
FULLMAKE:=  $(MAKE) -C $(TOP)util/make_dir -f TopMakefileOasis3 \
	ARCH=debian TOP=$(TOP)

override_dh_auto_build:
	$(FULLMAKE) CHAN=${CHAN} default
	# Create pkgconfig files.
	for p in mct.pc  psmile.pc  scrip.pc ; do \
		sed -e  's/@VERSION@/${VERSION}/' -e 's/@LIBDIR@/${LIBDIR_ESC}/' \
		  < debian/$${p}.in > debian/$${p}; \
		done
	# And docs
	$(MAKE) -C  lib/mct/doc 
	cd lib/mct/doc && dvipdf mct_APIs.dvi

override_dh_auto_install:
	mkdir -p debian/tmp/${LIBDIR}
	cp build/lib/libpsmile.${CHAN}.so debian/tmp/${LIBDIR}/libpsmile.${CHAN}.so.0d
	cp build/lib/libscrip.so debian/tmp/${LIBDIR}/libscrip.so.0d
	cp build/lib/*.a debian/tmp/${LIBDIR}
	dh_install -p liboasis3-dev debian/*.pc     ${LIBDIR}/pkgconfig

override_dh_link:
	dh_link -p liboasis3-dev ${LIBDIR}/libscrip.so.0d ${LIBDIR}/libscrip.so
	dh_link -p liboasis3-dev ${LIBDIR}/libpsmile.${CHAN}.a       ${LIBDIR}/libpsmile.a
	dh_link -p liboasis3-dev ${LIBDIR}/libpsmile.${CHAN}.so.0d   ${LIBDIR}/libpsmile.so
	dh_link -p liboasis3-dev /usr/include/psmile.${CHAN}        /usr/include/psmile

override_dh_shlibdeps:
	dh_shlibdeps -l$(TOP)/build/lib/shared

override_dh_fixperms:
	dh_fixperms

override_dh_clean:
	dh_clean
	$(MAKE) -C lib/mct/doc clean
	find . -name '.svn' -exec rm -rf {} \; || echo "Deleting .svn directories"
	rm -rf lib/mct/doc/*.pdf build
	$(FULLMAKE) realclean ARCH=debian || echo "realclean done already"


pkgconfig-files:
